###################################################
### chunk number 1: 
###################################################
#line 91 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
options(width=60)


###################################################
### chunk number 2: 
###################################################
#line 107 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
library(twang)


###################################################
### chunk number 3: 
###################################################
#line 116 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
data(lalonde)


###################################################
### chunk number 4: psfig
###################################################
#line 139 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,2))
ps.lalonde <- ps(treat ~ age + educ + black + hispan + nodegree +
                         married + re74 + re75,
                 data = lalonde,
                 plots="optimize",
                 stop.method=stop.methods[c("es.stat.mean","ks.stat.max")],
                 n.trees=2000,
                 interaction.depth=2,
                 shrinkage=0.01,
                 perm.test.iters=0,
                 verbose=FALSE)


###################################################
### chunk number 5: 
###################################################
#line 182 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
#line 139 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw#from line#182#"
par(mfrow=c(1,2))
ps.lalonde <- ps(treat ~ age + educ + black + hispan + nodegree +
                         married + re74 + re75,
                 data = lalonde,
                 plots="optimize",
                 stop.method=stop.methods[c("es.stat.mean","ks.stat.max")],
                 n.trees=2000,
                 interaction.depth=2,
                 shrinkage=0.01,
                 perm.test.iters=0,
                 verbose=FALSE)
#line 183 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"


###################################################
### chunk number 6: 
###################################################
#line 256 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,1))


###################################################
### chunk number 7: 
###################################################
#line 260 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
summary(ps.lalonde$gbm.obj,
        n.trees=ps.lalonde$desc$ks.stat.max$n.trees,
        plot=FALSE)


###################################################
### chunk number 8: 
###################################################
#line 268 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
summary(ps.lalonde$gbm.obj,
        n.trees=ps.lalonde$desc$ks.stat.max$n.trees)


###################################################
### chunk number 9: 
###################################################
#line 286 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
options(width=85)


###################################################
### chunk number 10: 
###################################################
#line 290 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
lalonde.balance <- bal.table(ps.lalonde)
lalonde.balance


###################################################
### chunk number 11: 
###################################################
#line 295 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
options(width=60)


###################################################
### chunk number 12: 
###################################################
#line 353 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
library(xtable)
pretty.tab <- lalonde.balance$ks.stat.max[,c("tx.mn","ct.mn","ks")]
pretty.tab <- cbind(pretty.tab, lalonde.balance$unw[,"ct.mn"])
names(pretty.tab) <- c("E(Y1|t=1)","E(Y0|t=1)","KS","E(Y0|t=0)")
xtable(pretty.tab,
       caption = "Balance of the treatment and comparison groups",
       label = "tab:balance",
       digits = c(0, 2, 2, 2, 2),
       align=c("l","r","r","r","r"))


###################################################
### chunk number 13: 
###################################################
#line 376 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
summary(ps.lalonde)


###################################################
### chunk number 14: 
###################################################
#line 429 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,2))
plot(ps.lalonde, plots="ps boxplot")
par(mfrow=c(1,1))


###################################################
### chunk number 15: 
###################################################
#line 444 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,2))
plot(ps.lalonde, plots="t pvalues")
par(mfrow=c(1,1))


###################################################
### chunk number 16: 
###################################################
#line 459 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,2))
plot(ps.lalonde, plots="es")
par(mfrow=c(1,1))


###################################################
### chunk number 17: 
###################################################
#line 487 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
library(survey)


###################################################
### chunk number 18: 
###################################################
#line 495 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
lalonde$w <- get.weights(ps.lalonde, type="ATT",stop.method="ks.stat.max")
design.ps <- svydesign(ids=~1, weights=~w, data=lalonde)


###################################################
### chunk number 19: 
###################################################
#line 523 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm1 <- svyglm(re78 ~ treat, design=design.ps)
summary(glm1)


###################################################
### chunk number 20: 
###################################################
#line 554 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm2 <- svyglm(re78 ~ treat + nodegree, design=design.ps)
summary(glm2)


###################################################
### chunk number 21: 
###################################################
#line 566 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm3 <- svyglm(re78 ~ treat + age + educ + black + hispan + nodegree +
                      married + re74 + re75,
               design=design.ps)
summary(glm3)


###################################################
### chunk number 22: 
###################################################
#line 579 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm4 <- lm(re78 ~ treat + age + educ + black + hispan + nodegree +
                  married + re74 + re75,
           data=lalonde)
summary(glm4)


###################################################
### chunk number 23: 
###################################################
#line 586 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm5 <- lm(sqrt(re78) ~ treat + age + educ + black + hispan + nodegree +
                        married + sqrt(re74) + sqrt(re75),
           data=lalonde)


###################################################
### chunk number 24: 
###################################################
#line 613 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
ps.logit <- glm(treat ~ age + educ + black + hispan + nodegree +
                        married + re74 + re75,
                data = lalonde,
                family = binomial)
lalonde$w.logit <- rep(1,nrow(lalonde))
lalonde$w.logit[lalonde$treat==0] <- exp(predict(ps.logit,subset(lalonde,treat==0)))


###################################################
### chunk number 25: 
###################################################
#line 629 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
bal.logit <- dx.wts(lalonde$w.logit,
                    data=lalonde,
                    vars=c("age","educ","black","hispan","nodegree","married","re74","re75"),
                    treat.var="treat",
                    perm.test.iters=0)
print(bal.logit)


###################################################
### chunk number 26: 
###################################################
#line 647 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
pretty.tab <- bal.table(bal.logit)[[2]][,c("tx.mn","ct.mn","ks")]
pretty.tab <- cbind(pretty.tab, bal.table(bal.logit)[[1]]$ct.mn)
names(pretty.tab) <- c("E(Y1|t=1)","E(Y0|t=1)","KS","E(Y0|t=0)")
xtable(pretty.tab,
       caption = "Logistic regression estimates of the propensity scores",
       label = "tab:balancelogit",
       digits = c(0, 2, 2, 2, 2),
       align=c("l","r","r","r","r"))


###################################################
### chunk number 27: 
###################################################
#line 661 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
bal.gbm <- dx.wts(ps.lalonde,
                  data=lalonde,
                  vars=c("age","educ","black","hispan","nodegree","married","re74","re75"),
                  treat.var="treat",
                  perm.test.iters=0)
pretty.tab <- rbind(bal.logit$summary.tab,
                    bal.gbm$summary.tab[-1,])
rownames(pretty.tab) <- pretty.tab$type
rownames(pretty.tab)[2] <- "logit"
pretty.tab <- pretty.tab[,c("n.treat","ess","max.es","mean.es","max.ks","mean.ks")]
xtable(pretty.tab,
       caption = "Summary of the balancing properties of logistic regression and gbm",
       label = "tab:balancecompare",
       digits = c(0, 0, 2, 2, 2, 2, 2),
       align=c("l","r","r","r","r","r","r"))


###################################################
### chunk number 28: 
###################################################
#line 679 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
design.logit <- svydesign(ids=~1, weights=~w.logit, data=lalonde)
glm6 <- svyglm(re78 ~ treat, design=design.logit)
summary(glm6)


###################################################
### chunk number 29: 
###################################################
#line 693 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
glm7 <- svyglm(re78 ~ treat + age + educ + black + hispan + nodegree +
                      married + re74 + re75,
               design=design.logit)


###################################################
### chunk number 30: 
###################################################
#line 780 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
data(egsingle)


###################################################
### chunk number 31: 
###################################################
#line 787 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
tmp <- sapply(split(egsingle,egsingle$childid),function(x){
              paste(as.character(x$grade),collapse="")})


###################################################
### chunk number 32: 
###################################################
#line 793 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
tmp <- data.frame(childid=names(tmp), gpatt=tmp,
                  resp=as.numeric((1:length(tmp)) %in%
                          grep("1234",as.character(tmp))))


###################################################
### chunk number 33: 
###################################################
#line 800 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
egsingle <- merge(egsingle, tmp)


###################################################
### chunk number 34: 
###################################################
#line 807 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
egsingle.one <-unique(egsingle[,-c(3:6)])


###################################################
### chunk number 35: 
###################################################
#line 813 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
egsingle.one$race <- as.factor(race <- ifelse(egsingle.one$black==1, 1,
                                         ifelse(egsingle.one$hispanic==1, 2, 3)))


###################################################
### chunk number 36: 
###################################################
#line 823 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
egsingle.one$nresp <- 1-egsingle.one$resp


###################################################
### chunk number 37: psfig2
###################################################
#line 827 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
par(mfrow=c(1,2))
egsingle.ps <-
   ps(nresp ~ race + female + size + lowinc + mobility,
      data=egsingle.one,
      plots="optimize",
      stop.method=stop.methods[c("es.stat.mean","ks.stat.max")],
      n.trees=2500,
      verbose=FALSE)


###################################################
### chunk number 38: 
###################################################
#line 840 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
#line 827 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw#from line#840#"
par(mfrow=c(1,2))
egsingle.ps <-
   ps(nresp ~ race + female + size + lowinc + mobility,
      data=egsingle.one,
      plots="optimize",
      stop.method=stop.methods[c("es.stat.mean","ks.stat.max")],
      n.trees=2500,
      verbose=FALSE)
#line 841 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"


###################################################
### chunk number 39: 
###################################################
#line 862 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
pretty.tab<-bal.table(egsingle.ps)$ks.stat.max[,c("tx.mn","ct.mn","std.eff.sz","ks")]
names(pretty.tab) <- c("Non-responders","Weighted responders","Std ES","KS")
xtable(pretty.tab,
       caption = "Balance of the nonrespondents and respondents",
       label = "tab:balance2",
       digits = c(0, 2, 2, 2, 2),
       align=c("l","r","r","r","r"))


###################################################
### chunk number 40: 
###################################################
#line 876 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
egsingle.one$wgt <- 1 + get.weights(egsingle.ps, type="ATT",
                                    stop.method="ks.stat.max")


###################################################
### chunk number 41: 
###################################################
#line 881 "d:/Rcompile/CRANpkg/local/2.12/twang/inst/doc/twang.rnw"
 egsinge.resp <- merge(subset(egsingle, subset=resp==1),
                       subset(egsingle.one, subset=resp==1,
                              select=c(childid, wgt)) )


